<?php

/* This file is part of Jeedom.
 *
 * Jeedom is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Jeedom is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Jeedom. If not, see <http://www.gnu.org/licenses/>.
 */

/* * ***************************Includes********************************* */
require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';

class constellation extends eqLogic {
    

    	static function send($_options) {
            $eqLogicLink = eqLogic::byId($_options['id']);
            $eqLogicTarget = cmd::byId($_options['event_id']);
            $target_name = (string) $eqLogicTarget->getName();
            $package_name = (string) $eqLogicLink->getName();
            $server_url = config::byKey('server_url', 'constellation');
            $sentinelle_name = config::byKey('sentinelle_name', 'constellation');
            $api_key = config::byKey('api_key', 'constellation'); 
            $test = $eqLogicTarget->getEqLogic();
            $test_id = $test->getId();
            $json = '{"Name":"'.$test->getHumanName().'","Value":{id:'.$test_id.',info:[';
            foreach ($test->getCmd('info') as $cmd) {
                $value = $cmd->execCmd();
                $unite = $cmd->getUnite();
                if(empty($unite)){
                    $unite = "null";
                }
                if (is_numeric($value)) {
                    $json .= "{id:".$cmd->getId().",name:\"".$cmd->getName()."\",value:".$value.",unit:\"".$unite."\"},";
                }else{
                   $json .= "{id:".$cmd->getId().",name:\"".$cmd->getName()."\",value:\"".$value."\",unit:\"".$unite."\"},";
               }
            }
            $json .= "]}}";
            log::add('constellation','debug',$json);
            $curl = curl_init();
            curl_setopt_array($curl, array(
            CURLOPT_PORT => "8088",
            CURLOPT_URL => "http://".$server_url."/rest/constellation/PushStateObject?SentinelName=".$sentinelle_name."&PackageName=".$package_name."&AccessKey=".$api_key,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $json,
            CURLOPT_HTTPHEADER => array(
                "cache-control: no-cache",
                "content-type: application/json",
            ),
            ));
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            log::add('constellation','debug',"envoi des données à Constellation");
            log::add('constellation','debug',print_r($response,true));
            log::add('constellation','debug',print_r($err,true));
	    }

        public function preUpdate() {

        }    
    
    	public function postSave() {
            
            log::add('constellation', 'info', 'ajout des équipements pour l\'envoi à Constellation');
            if ($this->getIsEnable() == 1) {
                $windows = $this->getConfiguration('window');
                $listener = listener::byClassAndFunction('constellation', 'send', array('id' => intval($this->getId())));
				if (!is_object($listener)) {
					$listener = new listener();
				}
				$listener->setClass('constellation');
				$listener->setFunction('send');
				$listener->setOption(array('id' => intval($this->getId())));
				$listener->emptyEvent();
				foreach ($windows as $window) {
					$listener->addEvent($window['cmd']);
				}
				$listener->save();
            }

        }

        public function preRemove() {
		// ne faudrait-il pas un switch ?
            log::add('constellation', 'info', 'suppression des équipements de la liste  l\'envoi à Constellation');
            $listener = listener::byClassAndFunction('constellation', 'send', array('id' => intval($this->getId())));
            if (is_object($listener)) {
                $listener->remove();
            }

        }

}

class constellationCmd extends cmd {
    /*     * *************************Attributs****************************** */


    /*     * ***********************Methode static*************************** */


    /*     * *********************Methode d'instance************************* */

    public function preSave() {
    }

    public function execute($_options = null) {
                        
        $package_name = $this->getEqLogic()->getName();
        $cmd_logical = $this->getLogicalId();
        $server_url = config::byKey('server_url', 'constellation');
        $sentinelle_name = config::byKey('sentinelle_name', 'constellation');
        $api_key = config::byKey('api_key', 'constellation');    


            $url = $server_url . '/rest/constellation/PushStateObject?SentinelName=' . trim($sentinelle_name) . '&PackageName='. trim($package_name) . '&AccessKey=' . trim($api_key) .  '&name=test&value=1';
            log::add('constellation','debug',print_r($url,true));
            $ch = curl_init($url);
            curl_exec($ch);
            curl_close($ch);

    }

    /*     * **********************Getteur Setteur*************************** */
}

?>