
/* This file is part of Jeedom.
*
* Jeedom is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Jeedom is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Jeedom. If not, see <http://www.gnu.org/licenses/>.
*/

$(function() {
    $("#table_cmd tbody").delegate(".listCmdconstellation", 'click', function(event) {
        $('.description').hide();
        $('.description.' + $('#sel_addPreConfigCmdconstellation').value()).show();
        $('#md_addPreConfigCmdconstellation').modal('show');
        $('#bt_addPreConfigCmdconstellationSave').undelegate().unbind();
        var tr = $(this).closest('tr');
        $("#div_mainContainer").delegate("#bt_addPreConfigCmdconstellationSave", 'click', function(event) {
            var cmd_data = json_decode($('.json_cmd.' + $('#sel_addPreConfigCmdconstellation').value()).value());
            tr.setValues(cmd_data, '.cmdAttr');
            $('#md_addPreConfigCmdconstellation').modal('hide');
        });
    });

    $("#sel_addPreConfigCmdconstellation").on('change', function(event) {
        $('.description').hide();
        $('.description.' + $(this).value()).show();

    });

    $("#table_cmd").sortable({axis: "y", cursor: "move", items: ".cmd", placeholder: "ui-state-highlight", tolerance: "intersect", forcePlaceholderSize: true});
});

 $("body").delegate(".listCmdInfoWindow", 'click', function () {
    var el = $(this).closest('.form-group').find('.expressionAttr[data-l1key=cmd]');
    jeedom.cmd.getSelectModal({cmd: {type: 'info', subtype: 'binary'}}, function (result) {
        el.value(result.human);
    });
});

 function saveEqLogic(_eqLogic) {
    if (!isset(_eqLogic.configuration)) {
        _eqLogic.configuration = {};
    }
    _eqLogic.configuration.window = $('#div_window .window').getValues('.expressionAttr');
    return _eqLogic;
}

function addCmdToTable(_cmd) {
    if (!isset(_cmd)) {
        var _cmd = {configuration: {}};
    }
    var tr = '<tr class="cmd" data-cmd_id="' + init(_cmd.id) + '">';
    tr += '<td class="name">';
    tr += '<input class="cmdAttr form-control input-sm" data-l1key="id" style="display : none;">';
    tr += '<input class="cmdAttr form-control input-sm" data-l1key="name">';
    tr += '<input class="cmdAttr form-control input-sm" data-l1key="logicalId" style="display : none;"></td>';
    tr += '<td style="display : none;" class="type" type="' + init(_cmd.type) + '">' + jeedom.cmd.availableType();
    tr += '<span class="subType" subType="' + init(_cmd.subType) + '"></span></td>';
     tr += '<td>';
    if (is_numeric(_cmd.id)) {
//                tr += '<a class="btn btn-default btn-xs cmdAction expertModeVisible" data-action="configure"><i class="fa fa-cogs"></i></a> ';
        tr += '<a class="btn btn-default btn-xs cmdAction" data-action="test"><i class="fa fa-rss"></i> {{Tester}}</a>';
    }
    tr += '</tr>';
    $('#table_cmd tbody').append(tr);
    $('#table_cmd tbody tr:last').setValues(_cmd, '.cmdAttr');
    jeedom.cmd.changeType($('#table_cmd tbody tr:last'), init(_cmd.subType));
}

 $('.addWindow').on('click', function () {
    addWindow({});
});

function addWindow(_info) {
    var div = '<div class="window">';
    div += '<div class="form-group ">';
    div += '<label class="col-sm-1 control-label">Equipement</label>';
    div += '<div class="col-sm-4">';
    div += '<div class="input-group">';
    div += '<span class="input-group-btn">';
    div += '<a class="btn btn-default bt_removeAction btn-sm" data-type="window"><i class="fa fa-minus-circle"></i></a>';
    div += '</span>';
    div += '<input class="expressionAttr form-control input-sm cmdInfo" data-l1key="cmd" />';
    div += '<span class="input-group-btn">';
    div += '<a class="btn btn-default btn-sm listCmdInfoWindow"><i class="fa fa-list-alt"></i></a>';
    div += '</span>';
    div += '</div>';
    div += '</div>';
    div += '</div>';
    $('#div_window').append(div);
    $('#div_window .window:last').setValues(_info, '.expressionAttr');
}

function printEqLogic(_eqLogic) {

    $('#div_window').empty();

    if (isset(_eqLogic.configuration)) {

        if (isset(_eqLogic.configuration.window)) {
            for (var i in _eqLogic.configuration.window) {
                addWindow(_eqLogic.configuration.window[i]);
            }
        }

    }
}
